<template>
  <div class="q-pa-md" >

    <div class="row justify-center" >
      <div class="col " style="width: 100%; max-width: 400px; min-width: 300px">
        <div class="cui-login-block-form" style="background: white">
          <h3 style="font-size: 1.75rem"><strong>Login</strong></h3>
          <br>
          <form v-on:submit.prevent="doLogin">
            <input type="hidden" name="submit" value="submit">
            <div class="form-group">
              <q-input v-model="email" type="email" label="Email" placeholder="Masukan Alamat Email" :dense="dense" />
            </div>
            <div class="form-group">
              <q-input v-model="password" label="Password" :type="isPwd ? 'password' : 'text'" hint="Masukan Password">
                <template v-slot:append>
                  <q-icon
                    :name="isPwd ? 'visibility_off' : 'visibility'"
                    class="cursor-pointer"
                    @click="isPwd = !isPwd"
                  />
                </template>
              </q-input>
            </div>
            <div class="form-group" style="margin-top: 10px;margin-bottom: 10px">
            </div>
            <div class="form-group">
<!--              <vue-recaptcha @verify="captchaExec" @reset="captchaReset" ref="recaptcha" class="g-recaptcha" id="g-recaptcha" :sitekey="captcha_key" size="normal">-->
<!--              </vue-recaptcha>-->
            </div>
            <div class="form-actions">
              <q-separator style="margin-bottom: 10px; margin-top: 10px; margin-left: 10px"  />
              <q-btn type="submit" style="background: #0190fe; border-color: #0190fe; cursor: pointer; color: white; border-radius: 4px; margin-right: 10px; width: 40%" data-style="expand-left">Login</q-btn>
              <q-btn to="register" style="background: #61cb33; color: white; width: 40%; float: right" data-style="expand-left">Registrasi</q-btn><br>
<!--              <q-separator style="margin-bottom: 10px; margin-top: 10px; margin-left: 10px"  />-->
<!--              <q-btn class="full-width" color="red" label="Sign In Google" @click="signInWithGoogle" />-->
              <google-login class="desktop-only" style="width: 300px; min-width: 250px"  :params="params" :renderParams="renderParams" :onSuccess="successGoogle" :onFailure="failureGoogle"/>
              <google-login class="mobile-only" style="width: 250px; min-width: 250px"  :params="params" :renderParams="renderParams" :onSuccess="successGoogle" :onFailure="failureGoogle"/>
<!--              <div id="g_id_onload"-->
<!--                   :data-client_id="params.client_id"-->
<!--                   :data-login_uri="url_login">-->
<!--              </div>-->
              <q-separator style="margin-bottom: 10px; margin-top: 10px; margin-left: 10px"  />
              <span class="register-link" style="padding-top: 15px">
                <a href="https://jarkons.com" style="color: #08f; Padding-right: 50px"><- Back To Home</a>
                <a href="https://jarkons.com/#/forgotPassword" style="color: #08f; float: right;">Forget Password?</a>
              </span>
            </div>
          </form>
        </div>
      </div>
      <div class="col" style="width: 100%; max-width: 400px" v-if="this.$q.platform.is.desktop">
        <div class="cui-login-block-sidebar" style="background: #61cb34">
          <h4 class="cui-login-block-sidebar-title"><strong>Jarkons Indonesia</strong></h4>
          <div class="cui-login-block-sidebar-item"> Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s. </div>
          <div class="cui-login-block-sidebar-item"> Ipsum has been the industry's standard dummy text ever since the 1500s.</div>
          <div class="cui-login-block-sidebar-place">
            <i class="icmn-location mr-3"></i> Jakarta, Indonesia
          </div>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
import VueRecaptcha from 'vue-recaptcha';
import { openURL } from 'quasar'
import GoogleLogin from 'vue-google-login'
import firebase from 'firebase/app';
import 'firebase/auth';
import 'firebase/database';

const appFirebase = firebase.initializeApp({
  apiKey: "AIzaSyD9hJgXnPPFj9PJrB0jOu9PSpAVxld9EZM",
  authDomain: "jarkons-309615.firebaseapp.com",
  projectId: "jarkons-309615",
  storageBucket: "jarkons-309615.appspot.com",
  messagingSenderId: "367851418111",
  appId: "1:367851418111:web:53a08df10a10986106f7ca",
  measurementId: "G-J3E974MQ55"
});
const auth = firebase.auth()

export default {
  name: "Login",
  components: {
    VueRecaptcha, GoogleLogin, firebase
  },
  data() {
    return {
      params: {
        client_id: "367851418111-v7gh094sv6lj52aclo65riuirpckb4i8.apps.googleusercontent.com",
        ux_mode: 'popup',
      },
      renderParams: {
        height: 50,
        ux_mode: 'popup',
        longtitle: true
      },
      password: null,
      googleUrl: process.env.GOOGLE_URL.replace(/['"]+/g, ''),
      isPwd: true,
      dense: null,
      email: null,
      url_login: '/api/login',
      captchaResponse: null,
      captcha_key: "6LeenLoZAAAAAOxj2Hek9yzsrT6YMBHgcNrmrtU4"
    }
  },
  methods:  {
    successGoogle(googleUser) {
      let id_token = googleUser.getAuthResponse().id_token
      this.$q.loading.show()
      this.$axios.post('/api/login-google', {"id_token": id_token})
      .then(sukses => {
        let token = sukses.data.success.token
        localStorage.setItem("token", token)
        this.$router.push("/")
        this.$q.loading.hide()
      })
    },
    failureGoogle(gagal) {
      this.$q.loading.hide()
    },
    openLink(link) {
      openURL(link)
    },
    async doLogin () {
      await this.$recaptchaLoaded()
      this.captchaResponse = await this.$recaptcha('login')
      let pesan = "Masukan Captcha";
      let formData = new FormData();
      formData.append("email", this.email)
      formData.append("password", this.password)
      formData.append("captcha_token", this.captchaResponse)

      if (!this.email || !this.password) {
        pesan = "Masukan Email atau Password"
        this.notifikasi(pesan)
      } else {
        if (!this.captchaResponse) {
          this.notifikasi(pesan)
        } else {
          this.$q.loading.show()
          this.$axios.post(this.url_login, formData)
            .then(sukses => {
              let token = sukses.data.success.token
              localStorage.setItem("token", token)
              this.$q.loading.hide()
              this.$router.push("/")
            })
            .catch(error => {
              console.log("error", error.response)
              let pesan = error.response.data.error;
              this.$q.loading.hide()
              this.notifikasi(pesan)
              setTimeout('', 1000);
              this.$refs.recaptcha.reset();
            })
        }
      }

    },
    notifikasi: function (pesanError) {
      this.$q.notify({
        position: "top",
        type: 'negative',
        message: pesanError
      })
    },
    captchaExec: function (response) {
      this.captchaResponse = response
    },
    captchaReset: function (response) {

    },
    signInWithGoogle() {
      var googleProvider = new firebase.auth.GoogleAuthProvider();
      auth.signInWithRedirect(googleProvider).then(() => {
        return firebase.auth().getRedirectResult();
      })
      .then(sukses => {
        // console.log(sukses.credential.idToken)
        this.$q.loading.show()
        this.$axios.post('/api/login-google', {"id_token": sukses.credential.idToken})
          .then(sukses => {
            let token = sukses.data.success.token
            localStorage.setItem("token", token)
            this.$router.push("/")
            this.$q.loading.hide()
          })

      })
      .catch(gagal => {
        console.log(gagal)
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.googlemobile {
  width: 300px;
@media screen and (min-width: 0px) and (max-width: 991px) {
  width: 250px;
}
}


.cui-login-block-sidebar {
  display: block;
  /*position: absolute;*/
  width: 23.07rem;
  padding: 3.07rem;
  height: 550px;
  color: #fff;
}
.cui-login-block-sidebar-item {
  padding-left: 1.53rem;
  border-left: 2px solid #74708d;
  margin-bottom: 1.53rem;
  color: #f7efef;
}

  .cui-login-block-form{
    padding: 3.07rem;
    height: 550px;
  }

.g-recaptcha {
  transform:scale(0.77);
  transform-origin:0 0;
}
#g-recaptcha {
  transform:scale(0.77);
  transform-origin:0 0;
}
</style>
